--instantiate functions
--local SetupOptions
----

function BK_OptionsLoad(panel)
	SlashCmdList["BADKITTY"] = BK_Slashes
	SLASH_BADKITTY1 = "/badkitty"
	SLASH_BADKITTY2 = "/bk"
	panel.name = "BadKitty"
	InterfaceOptions_AddCategory(panel)
	--BK_LoadChild(_G["BKOptionsWarning"],"Warning Options")
	--BK_SetupOptions()
end

function BK_LoadChild(panel,name)	--Only for children!
	panel.name = name
	panel.parent = "BadKitty"
	InterfaceOptions_AddCategory(panel)
end

function BK_Slashes(msg)
	if msg=="lock" or msg=="move" then
		BK_Move()
	else
		BK_OpenOptions() 
	end
end

function BK_OpenOptions()
	InterfaceOptionsFrame_OpenToCategory(BKOptionsWarning) --so the tabs are expanded when opened
	InterfaceOptionsFrame_OpenToCategory(BKOptions)
end

function BK_SizeWarnings()
	BKSettings["warningsize"] = BKOptionsWarningSize:GetValue()
	BK_Refresh()
end

function BK_WarningFont()
	BKSettings["warningfont"] = BKOptionsWarningFont:GetValue()
	BK_Refresh()
end

function BK_BarFont()
	BKSettings["barfont"] = BKOptionsBarFont:GetValue()
	BK_Refresh()
end

function BK_WarningShape()
	BKSettings["warninglayout"]["size"] = BKOptionsWarningShape:GetValue()
	BK_Refresh()
end

function BK_SetColumnRadio()	--warning shape
	if BKSettings["warninglayout"]["direction"]=="c" then 
		BKOptionsWarningDirectionC:SetChecked(1) 
	else 
		BKOptionsWarningDirectionC:SetChecked(0) 
	end
end

function BK_SetRowRadio()	--warning shape
	if BKSettings["warninglayout"]["direction"]=="r" then 
		BKOptionsWarningDirectionR:SetChecked(1) 
	else 
		BKOptionsWarningDirectionR:SetChecked(0) 
	end
end

function BK_CheckRadios()	--updates BKSettings with the warning shape direction
	if BKOptionsWarningDirectionC:GetChecked() then
		BKSettings["warninglayout"]["direction"]="c"
	else
		BKSettings["warninglayout"]["direction"]="r"
	end
	BK_Refresh()
end

--if you look closely at the next two functions...they're set up retarded.
--something was acting weird with pairs(), so I was forced to do the iteration this way.
function BK_ToggleCatSpell(spell,switch)
	local spell = spell
	if switch then
		local i = 1
		while true do
			if not BKSettings["barorder"]["BKBar"..i] then break end
			if BKSettings["barorder"]["BKBar"..i]==spell then
				return
			end
			i = i+1
		end
		i = 1
		while true do
			if not BKSettings["barorder"]["BKBar"..i] then break end
			if BKSettings["barorder"]["BKBar"..i]=="no" then
				BKSettings["barorder"]["BKBar"..i]=spell
				break
			end
			i = i+1
		end
	else
		local i = 1
		while true do
			if not BKSettings["barorder"]["BKBar"..i] then break end
			if BKSettings["barorder"]["BKBar"..i]==spell then
				BKSettings["barorder"]["BKBar"..i]="no"
				while true do
					if not BKSettings["barorder"]["BKBar"..i+1]then 
						BKSettings["barorder"]["BKBar"..i]="no"
						break 
					end
					BKSettings["barorder"]["BKBar"..i]=BKSettings["barorder"]["BKBar"..i+1]
					i=i+1
				end
				break
			end
			i=i+1
		end
	end
	BK_Refresh()
end	

function BK_UpdateBars() --takes BKCatSpells and pushes it to the options window, ["barorder"] and barOrder
	local i = 1	 --also updates the color picker button
	while true do
		if i>#(BKCatSpells) then break end
		_G["BKOptionsBarToggle"..i.."Text"]:SetText(BKCatSpells[i])
		_G["BKOptionsBarColor"..i.."Texture"]:SetTexture(BKSettings["barcolor"][BKCatSpells[i]][1],BKSettings["barcolor"][BKCatSpells[i]][3],BKSettings["barcolor"][BKCatSpells[i]][3])
		i=i+1
	end
	i=1
	local slist ={} 
 	for i,j in pairs(BKSettings["barorder"]) do
		slist[j]=i
	end
	while true do
		if i>#(BKCatSpells) then break end
			if slist[BKCatSpells[i]] then
				BKSettings["barorder"]["BKBar"..i]=BKCatSpells[i]
			end
		i=i+1
	end
	barOrder=BKSettings["barorder"]
end

-- checks if a bar is turned off, makes a check to reflect it
function BK_CheckBars()
	local i=1
	while true do
		if i>#(BKCatSpells) then break end
		local spell = _G["BKOptionsBarToggle"..i.."Text"]:GetText()
		local j = 1
		while true do
			_G["BKOptionsBarToggle"..i]:SetChecked(0)
			if not BKSettings["barorder"]["BKBar"..j] then break end
			if spell == BKSettings["barorder"]["BKBar"..j] then
				_G["BKOptionsBarToggle"..i]:SetChecked(1)
				break
			end
			j = j+1
		end
		i = i+1
	end
end

--runs through the cat bar checks and makes them happen
function BK_PushCatChecks()
	local i=1
	local _G = getfenv()
	while true do
		if i>#(BKCatSpells) then break end
		if _G["BKOptionsBarToggle"..i]:GetChecked() then
			BK_ToggleCatSpell(BKCatSpells[i],1)
		else
			BK_ToggleCatSpell(BKCatSpells[i],nil)
		end
		i = i+1
	end
	BK_Refresh()
end

function BKB()
	local i =1
	while true do
		if BKSettings["barorder"]["BKBar"..i] then
			BKO("BKBar"..i.." "..BKSettings["barorder"]["BKBar"..i])
		else
			break
		end
		i=i+1
	end
end

function BK_MoveWarningUp(i)
	if not _G["BKOptionsWarningOnOff"..i]:GetChecked() then
		_G["BKOptionsWarningOnOff"..i]:SetChecked(1)
	end
	local text = _G["BKOptionsWarningOnOff"..i.."Text"]:GetText()
	local temp = _G["BKOptionsWarningOnOff"..(i-1).."Text"]:GetText()
	BKSettings["warnorder"][text] = i-1
	BKSettings["warnorder"][temp] = i
	BK_CheckWarnings()
	BK_Refresh()
end

function BK_MoveWarningDown(i)
	if not _G["BKOptionsWarningOnOff"..i]:GetChecked() then
		_G["BKOptionsWarningOnOff"..i]:SetChecked(1)
	end
	local text = _G["BKOptionsWarningOnOff"..i.."Text"]:GetText()
	local temp = _G["BKOptionsWarningOnOff"..(i+1)
	.."Text"]:GetText()
	BKSettings["warnorder"][text] = i+1
	BKSettings["warnorder"][temp] = i
	BK_CheckWarnings()
	BK_Refresh()
end

function BK_MoveBarUp(i)
	if not _G["BKOptionsBarToggle"..i]:GetChecked() then
		_G["BKOptionsBarToggle"..i]:SetChecked(1)
	end
	local text = _G["BKOptionsBarToggle"..i.."Text"]:GetText()
	local temp = _G["BKOptionsBarToggle"..(i-1).."Text"]:GetText()
	BKSettings["barorder"]["BKBar"..i-1] = text 
	BKSettings["barorder"]["BKBar"..i] = temp
	BKCatSpells[i-1]=text
	BKCatSpells[i]=temp
	BK_CheckBars()
	BK_UpdateBars()
	--BK_Refresh()
end

function BK_MoveBarDown(i)
	if not _G["BKOptionsBarToggle"..i]:GetChecked() then
		_G["BKOptionsBarToggle"..i]:SetChecked(1)
	end
	local text = _G["BKOptionsBarToggle"..i.."Text"]:GetText()
	local temp = _G["BKOptionsBarToggle"..(i+1)
	.."Text"]:GetText()
	BKSettings["barorder"]["BKBar"..i+1] = text
	BKSettings["barorder"]["BKBar"..i] = temp
	BKCatSpells[i+1]=text
	BKCatSpells[i]=temp
	BK_CheckBars()
	BK_UpdateBars()
	--BK_Refresh()
end

function BK_CheckWarnings()
	local i = 1
	while true do
		if not _G["BKOptionsWarningOnOff"..i] then break end
		_G["BKOptionsWarningOnOff"..i]:SetChecked(0)
		i = i+1
	end
	for spell,frame in pairs(BKSettings["warnorder"]) do
		if frame~="no" then
			_G["BKOptionsWarningOnOff"..frame.."Text"]:SetText(spell)
			_G["BKOptionsWarningOnOff"..frame]:SetChecked(1)
		end
	end
end

function BK_ToggleWarning(i)
	local text = _G["BKOptionsWarningOnOff"..i.."Text"]:GetText()
	if not _G["BKOptionsWarningOnOff"..i]:GetChecked() then
		BKSettings["warnorder"][text] = "no"
	else
		BKSettings["warnorder"][text] = i
	end
	BK_Refresh()
end

function BK_ToggleBar(i) --This function is causing issues, possibly.
	local text = _G["BKOptionsBarToggle"..i.."Text"]:GetText()
	if not _G["BKOptionsBarToggle"..i]:GetChecked() then
		BKSettings["barorder"]["BKBar"..i] = "no" 
	else
		BKSettings["barorder"]["BKBar"..i] = text
	end
	BK_Refresh()
end


function BK_BarOpacity()
	BKSettings["barbackalpha"] = BKOptionsBarOpacity:GetValue()
	BK_Refresh()
end

function BK_BarLock()
	BKSettings["barlock"] = BKOptionsBarLock:GetChecked()
	if not BKSettings["barlock"] then 
		local i = 2
		_G["BKOptionsBarDown1"]:Disable()
		while true do
			if i>#(BKCatSpells) then break end
			_G["BKOptionsBarDown"..i]:Disable()
			_G["BKOptionsBarUp"..i]:Disable()
			i = i+1
		end
	else
		local i = 2
		_G["BKOptionsBarDown1"]:Enable()
		while true do
			if i>#(BKCatSpells) then break end
			_G["BKOptionsBarDown"..i]:Enable()
			_G["BKOptionsBarUp"..i]:Enable()
			i = i+1
		end
	end
end

function BK_PickColor(list)
	local r,g,b=unpack(list)
	ColorPickerFrame:SetColorRGB(r,g,b)
	ColorPickerFrame.hasOpacity = nil
	ColorPickerFrame.func, ColorPickerFrame.cancelFunc = BK_Callback,BK_Callback
	ColorPickerFrame:Hide()
	ColorPickerFrame:Show()
end

function BK_Callback(restore)
	local r,g,b
	if restore then
		r,g,b=unpack(restore)
	else
		r,g,b=ColorPickerFrame:GetColorRGB()
	end
	BKSettings["barcolor"][BKColoredSpell]={r,g,b}
end

function BK_SetupOptions() --it's local (but not right now)
	local _G = getfenv()
	----Main Window----
	----Warning Window----
	BKOptionsWarning:CreateFontString("BKOptionsWarningSizeTitle","OVERLAY","GameFontNormalSmall")
	BKOptionsWarning:CreateFontString("BKOptionsWarningFontTitle","OVERLAY","GameFontNormalSmall")
	BKOptionsWarning:CreateFontString("BKOptionsWarningShapeTitle","OVERLAY","GameFontNormalSmall")
	
	BKOptionsWarningCatToggle:ClearAllPoints()
	BKOptionsWarningCatToggle:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",20,-20)
	BKOptionsWarningCatToggle:CreateTexture("BKOptionsWarningCatToggleText","OVERLAY")
	BKOptionsWarningCatToggleText:SetText("Cat Warnings")
	BKOptionsWarningCatToggle:SetScript("OnShow",function() BKOptionsWarningCatToggle:SetChecked(BKSettings["catwarningson"]); BK_Refresh() end)
	BKOptionsWarningCatToggle:SetScript("OnClick",function() BKSettings["catwarningson"]=BKOptionsWarningCatToggle:GetChecked() end)
	
	BKOptionsWarningSizeTitle:SetText("Warning Size")
	BKOptionsWarningSize:ClearAllPoints()
	BKOptionsWarningSize:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",200,-25)
	BKOptionsWarningSizeTitle:SetPoint("BOTTOM",BKOptionsWarningSize,"TOP",-20,0)
	BKOptionsWarningSize:SetValue(BKSettings["warningsize"])
	BKOptionsWarningSize:SetScript("OnValueChanged",BK_SizeWarnings)
	BKOptionsWarningSize:SetScript("OnUpdate",function() BKOptionsWarningSizeText:SetText(floor(BKSettings["warningsize"])) end)
	
	BKOptionsWarningFontTitle:SetText("Font")
	BKOptionsWarningFont:ClearAllPoints()
	BKOptionsWarningFont:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",200,-55)
	BKOptionsWarningFontTitle:SetPoint("BOTTOM",BKOptionsWarningFont,"TOP",-20,0)
	BKOptionsWarningFont:SetValue(BKSettings["warningfont"])
	BKOptionsWarningFont:SetScript("OnValueChanged",BK_WarningFont)
	BKOptionsWarningFont:SetMinMaxValues(0,36)
	BKOptionsWarningFont:SetScript("OnUpdate",function() BKOptionsWarningFontText:SetText(floor(BKSettings["warningfont"])) end)
	
	BKOptionsWarningShapeTitle:SetText("# of Columns/Rows")
	BKOptionsWarningShape:ClearAllPoints()
	BKOptionsWarningShape:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",200,-85)
	BKOptionsWarningShapeTitle:SetPoint("BOTTOM",BKOptionsWarningShape,"TOP",-20,0)
	BKOptionsWarningShape:SetValue(BKSettings["warninglayout"]["size"])
	BKOptionsWarningShape:SetMinMaxValues(1,12)
	BKOptionsWarningShape:SetValueStep(1)
	BKOptionsWarningShape:SetScript("OnShow",function() BKOptionsWarningShape:SetValue(BKSettings["warninglayout"]["size"]) end)
	BKOptionsWarningShape:SetScript("OnValueChanged",BK_WarningShape)
	BKOptionsWarningShape:SetScript("OnUpdate",function() BKOptionsWarningShapeText:SetText(BKSettings["warninglayout"]["size"]) end)
	
	BKOptionsWarningDirectionC:CreateTexture("BKOptionsWarningDirectionCText","OVERLAY")
	BKOptionsWarningDirectionCText:SetText("Columns")
	BKOptionsWarningDirectionC:SetPoint("TOP",BKOptionsWarningShape,"BOTTOMLEFT")
	BKOptionsWarningDirectionC:SetScript("OnShow",BK_SetColumnRadio)
	BKOptionsWarningDirectionC:SetScript("OnClick",function() BKOptionsWarningDirectionR:SetChecked(0); BK_CheckRadios() end)
	
	BKOptionsWarningDirectionR:CreateTexture("BKOptionsWarningDirectionRText","OVERLAY")
	BKOptionsWarningDirectionRText:SetText("Rows")
	BKOptionsWarningDirectionR:SetPoint("TOP",BKOptionsWarningShape,"BOTTOMLEFT",90,0)
	BKOptionsWarningDirectionR:SetScript("OnShow",BK_SetRowRadio)
	BKOptionsWarningDirectionR:SetScript("OnClick",function() BKOptionsWarningDirectionC:SetChecked(0); BK_CheckRadios() end)
	
	local i=1
	local x = 20
	local y = -100
	while true do
		if not _G["BKOptionsWarningOnOff"..i] then break end
		_G["BKOptionsWarningOnOff"..i]:CreateTexture("BKOptionsWarningOnOff"..i.."Text","OVERLAY")
		_G["BKOptionsWarningOnOff"..i.."Text"]:ClearAllPoints()
		_G["BKOptionsWarningOnOff"..i.."Text"]:SetPoint("LEFT","BKOptionsWarningOnOff"..i,"RIGHT",40,0)
		_G["BKOptionsWarningOnOff"..i]:ClearAllPoints()
		_G["BKOptionsWarningDown"..i]:ClearAllPoints()
		_G["BKOptionsWarningUp"..i]:ClearAllPoints()
		_G["BKOptionsWarningOnOff"..i]:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",x,y)
		_G["BKOptionsWarningDown"..i]:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",x+30,y-8)
		_G["BKOptionsWarningUp"..i]:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",x+50,y-8)
		if i==1 then _G["BKOptionsWarningOnOff"..i]:SetScript("OnShow",BK_CheckWarnings) end
		_G["BKOptionsWarningOnOff"..i]:SetScript("OnClick",BK_ToggleWarning)		
		y = y-30
		i = i+1
	end
	--grrrrrrrrrrrrrrrrrrr
	--_G["BKOptionsWarningUp1"]:SetScript("OnClick",BK_MoveWarningUp(1))		--can't go higher!
	BKOptionsWarningUp1:Hide()
	_G["BKOptionsWarningDown1"]:SetScript("OnClick",function() BK_MoveWarningDown(1) end)
	_G["BKOptionsWarningUp2"]:SetScript("OnClick",function() BK_MoveWarningUp(2) end)
	_G["BKOptionsWarningDown2"]:SetScript("OnClick",function() BK_MoveWarningDown(2) end)
	_G["BKOptionsWarningUp3"]:SetScript("OnClick",function() BK_MoveWarningUp(3) end)
	_G["BKOptionsWarningDown3"]:SetScript("OnClick",function() BK_MoveWarningDown(3) end)
	_G["BKOptionsWarningUp4"]:SetScript("OnClick",function() BK_MoveWarningUp(4) end)
	_G["BKOptionsWarningDown4"]:SetScript("OnClick",function() BK_MoveWarningDown(4) end)
	_G["BKOptionsWarningUp5"]:SetScript("OnClick",function() BK_MoveWarningUp(5) end)
	_G["BKOptionsWarningDown5"]:SetScript("OnClick",function() BK_MoveWarningDown(5) end)
	_G["BKOptionsWarningUp6"]:SetScript("OnClick",function() BK_MoveWarningUp(6) end)
	_G["BKOptionsWarningDown6"]:SetScript("OnClick",function() BK_MoveWarningDown(6) end)
	_G["BKOptionsWarningUp7"]:SetScript("OnClick",function() BK_MoveWarningUp(7) end)
	_G["BKOptionsWarningDown7"]:SetScript("OnClick",function() BK_MoveWarningDown(7) end)
	_G["BKOptionsWarningUp8"]:SetScript("OnClick",function() BK_MoveWarningUp(8) end)
	_G["BKOptionsWarningDown8"]:SetScript("OnClick",function() BK_MoveWarningDown(8) end)
	_G["BKOptionsWarningUp9"]:SetScript("OnClick",function() BK_MoveWarningUp(9) end)
	_G["BKOptionsWarningDown9"]:SetScript("OnClick",function() BK_MoveWarningDown(9) end)
	_G["BKOptionsWarningUp10"]:SetScript("OnClick",function() BK_MoveWarningUp(10) end)
	--_G["BKOptionsWarningDown10"]:SetScript("OnClick",BK_MoveWarningDown(1))	--can't go lower!
	BKOptionsWarningDown10:Hide()
	_G["BKOptionsWarningOnOff1"]:SetScript("OnClick",function() BK_ToggleWarning(1) end)
	_G["BKOptionsWarningOnOff2"]:SetScript("OnClick",function() BK_ToggleWarning(2) end)
	_G["BKOptionsWarningOnOff3"]:SetScript("OnClick",function() BK_ToggleWarning(3) end)
	_G["BKOptionsWarningOnOff4"]:SetScript("OnClick",function() BK_ToggleWarning(4) end)
	_G["BKOptionsWarningOnOff5"]:SetScript("OnClick",function() BK_ToggleWarning(5) end)
	_G["BKOptionsWarningOnOff6"]:SetScript("OnClick",function() BK_ToggleWarning(6) end)
	_G["BKOptionsWarningOnOff7"]:SetScript("OnClick",function() BK_ToggleWarning(7) end)
	_G["BKOptionsWarningOnOff8"]:SetScript("OnClick",function() BK_ToggleWarning(8) end)
	_G["BKOptionsWarningOnOff9"]:SetScript("OnClick",function() BK_ToggleWarning(9) end)
	_G["BKOptionsWarningOnOff10"]:SetScript("OnClick",function() BK_ToggleWarning(10) end)
	
	----Bar Window----
	BKOptionsBar:CreateFontString("BKOptionsBarWidthTitle","OVERLAY","GameFontNormalSmall")
	BKOptionsBar:CreateFontString("BKOptionsBarFontTitle","OVERLAY","GameFontNormalSmall")
	BKOptionsBar:CreateFontString("BKOptionsBarOpacityTitle","OVERLAY","GameFontNormalSmall")
	BKOptionsBar:CreateFontString("BKOptionsBarHeightTitle","OVERLAY","GameFontNormalSmall")
	BKOptionsBar:CreateFontString("BKOptionsBarToggles","OVERLAY","GameFontNormalLarge")
	
	BKOptionsBarToggles:ClearAllPoints()
	BKOptionsBarToggles:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",20,-120)
	--BKOptionsBarToggles:SetText("REPLACE THIS")
	
	BKOptionsBarCatToggle:ClearAllPoints()
	BKOptionsBarCatToggle:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",20,-20)
	BKOptionsBarCatToggle:CreateTexture("BKOptionsBarCatToggleText","OVERLAY")
	BKOptionsBarCatToggleText:SetText("Cat Bars")
	BKOptionsBarCatToggle:SetScript("OnShow",function() BKOptionsBarCatToggle:SetChecked(BKSettings["catbarson"]); BK_Refresh() end)
	BKOptionsBarCatToggle:SetScript("OnClick",function() BKSettings["catbarson"]=BKOptionsBarCatToggle:GetChecked() end)
	
	BKOptionsBarWidthTitle:SetText("Bar Width")
	BKOptionsBarWidth:ClearAllPoints()
	BKOptionsBarWidth:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",230,-25)
	BKOptionsBarWidthTitle:SetPoint("BOTTOM",BKOptionsBarWidth,"TOP",-20,0)
	BKOptionsBarWidth:SetValue(BKSettings["barwidth"])
	BKOptionsBarWidth:SetScript("OnValueChanged",function() BKSettings["barwidth"]=BKOptionsBarWidth:GetValue(); BK_Refresh() end)
	BKOptionsBarWidth:SetScript("OnUpdate",function() BKOptionsBarWidthText:SetText(floor(BKSettings["barwidth"])) end)
	BKOptionsBarWidth:SetMinMaxValues(75,300)
	
	BKOptionsBarFontTitle:SetText("Font")
	BKOptionsBarFont:ClearAllPoints()
	BKOptionsBarFont:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",230,-85)
	BKOptionsBarFontTitle:SetPoint("BOTTOM",BKOptionsBarFont,"TOP",-20,0)
	BKOptionsBarFont:SetValue(BKSettings["barfont"])
	BKOptionsBarFont:SetScript("OnValueChanged",BK_BarFont)
	BKOptionsBarFont:SetMinMaxValues(0,36)
	BKOptionsBarFont:SetScript("OnUpdate",function() BKOptionsBarFontText:SetText(floor(BKSettings["barfont"])) end)
	
	BKOptionsBarOpacityTitle:SetText("Background Opacity")
	BKOptionsBarOpacity:ClearAllPoints()
	BKOptionsBarOpacity:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",230,-115)
	BKOptionsBarOpacityTitle:SetPoint("BOTTOM",BKOptionsBarOpacity,"TOP",-20,0)
	BKOptionsBarOpacity:SetScript("OnValueChanged",BK_BarOpacity)
	BKOptionsBarOpacity:SetMinMaxValues(0,1)
	BKOptionsBarOpacity:SetValueStep(0.01)
	BKOptionsBarOpacity:SetScript("OnShow",function () BKOptionsBarOpacity:SetValue(BKSettings["barbackalpha"]) end)
	BKOptionsBarOpacity:SetScript("OnUpdate",function() BKOptionsBarOpacityText:SetText(floor(100*BKSettings["barbackalpha"])/100) end)
	
	BKOptionsBarHeightTitle:SetText("Bar Height")
	BKOptionsBarHeight:ClearAllPoints()
	BKOptionsBarHeight:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",230,-55)
	BKOptionsBarHeightTitle:SetPoint("BOTTOM",BKOptionsBarHeight,"TOP",-20,0)
	BKOptionsBarHeight:SetValue(BKSettings["barheight"])
	BKOptionsBarHeight:SetScript("OnValueChanged",function() BKSettings["barheight"]=BKOptionsBarHeight:GetValue(); BK_Refresh() end)
	BKOptionsBarHeight:SetScript("OnUpdate",function() BKOptionsBarHeightText:SetText(floor(BKSettings["barheight"])) end)
	BKOptionsBarHeight:SetMinMaxValues(5,100)
	
	BKOptionsBarCombat:ClearAllPoints()
	BKOptionsBarCombat:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",20,-55)
	BKOptionsBarCombat:CreateTexture("BKOptionsBarCombatText","OVERLAY")
	BKOptionsBarCombatText:SetText("Hidden Out of Combat")
	BKOptionsBarCombat:SetScript("OnShow",function() BKOptionsBarCombat:SetChecked(BKSettings["barcombat"]); BK_Refresh() end)
	BKOptionsBarCombat:SetScript("OnClick",function() BKSettings["barcombat"]=BKOptionsBarCombat:GetChecked() end)
	
	BKOptionsBarScale:ClearAllPoints()
	BKOptionsBarScale:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",20,-80)
	BKOptionsBarScale:CreateTexture("BKOptionsBarScaleText","OVERLAY")
	BKOptionsBarScaleText:SetText("Bars Scale with Cooldown Length")
	BKOptionsBarScale:SetScript("OnShow",function() BKOptionsBarScale:SetChecked(BKSettings["barscale"]); BK_Refresh() end)
	BKOptionsBarScale:SetScript("OnClick",function() BKSettings["barscale"]=BKOptionsBarScale:GetChecked() end)
	
	BKOptionsBarLock:ClearAllPoints()
	BKOptionsBarLock:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",20,-105)
	BKOptionsBarLock:CreateTexture("BKOptionsBarLockText","OVERLAY")
	BKOptionsBarLockText:SetText("Static Bar Order")
	BKOptionsBarLock:SetScript("OnShow",function() BKOptionsBarLock:SetChecked(BKSettings["barlock"]); BK_Refresh(); BK_BarLock() end)
	BKOptionsBarLock:SetScript("OnClick",BK_BarLock)
	

	local i=1
	local y = -175
	local x = 20
	while true do
		if i>#(BKCatSpells) then break end
		_G["BKOptionsBarToggle"..i]:ClearAllPoints()
		_G["BKOptionsBarToggle"..i]:SetPoint("TOPLEFT",BKOptionsBar,"TOPLEFT",x,y)
		_G["BKOptionsBarToggle"..i]:CreateTexture("BKOptionsBarToggle"..i.."Text","OVERLAY")
		_G["BKOptionsBarToggle"..i.."Text"]:SetText(BKCatSpells[i])
		_G["BKOptionsBarToggle"..i.."Text"]:ClearAllPoints()
		_G["BKOptionsBarToggle"..i.."Text"]:SetPoint("LEFT","BKOptionsBarToggle"..i,"RIGHT",40,0)
		_G["BKOptionsBarDown"..i]:ClearAllPoints()
		_G["BKOptionsBarUp"..i]:ClearAllPoints()
		_G["BKOptionsBarDown"..i]:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",x+30,y-8)
		_G["BKOptionsBarUp"..i]:SetPoint("TOPLEFT",BKOptionsWarning,"TOPLEFT",x+50,y-8)
		_G["BKOptionsBarColor"..i]:ClearAllPoints()
		_G["BKOptionsBarColor"..i]:SetPoint("TOPLEFT","BKOptionsBarToggle"..i,"TOPLEFT",100,8)
		_G["BKOptionsBarColor"..i]:CreateTexture("BKOptionsBarColor"..i.."Texture","OVERLAY")
		_G["BKOptionsBarColor"..i.."Texture"]:SetHeight(15)
		_G["BKOptionsBarColor"..i.."Texture"]:SetWidth(15)
		_G["BKOptionsBarColor"..i]:SetHeight(15)
		_G["BKOptionsBarColor"..i]:SetWidth(15)
		_G["BKOptionsBarColor"..i]:Show()
		if i==1 then 
			_G["BKOptionsBarToggle1"]:SetScript("OnShow",BK_CheckBars) 
			_G["BKOptionsBarColor1"]:SetScript("OnShow",BK_BarUpdate)
		end
		_G["BKOptionsBarToggle"..i]:SetScript("OnClick",BK_PushCatChecks)
		i = i+1
		y = y - 25
	end
	--grrrrrrrrrrrrrrrrrrr
	--_G["BKOptionsBarUp1"]:SetScript("OnClick",BK_MoveBarUp(1))		--can't go higher!
	BKOptionsBarUp1:Hide()
	_G["BKOptionsBarDown1"]:SetScript("OnClick",function() BK_MoveBarDown(1) end)
	_G["BKOptionsBarUp2"]:SetScript("OnClick",function() BK_MoveBarUp(2) end)
	_G["BKOptionsBarDown2"]:SetScript("OnClick",function() BK_MoveBarDown(2) end)
	_G["BKOptionsBarUp3"]:SetScript("OnClick",function() BK_MoveBarUp(3) end)
	_G["BKOptionsBarDown3"]:SetScript("OnClick",function() BK_MoveBarDown(3) end)
	_G["BKOptionsBarUp4"]:SetScript("OnClick",function() BK_MoveBarUp(4) end)
	_G["BKOptionsBarDown4"]:SetScript("OnClick",function() BK_MoveBarDown(4) end)
	_G["BKOptionsBarUp5"]:SetScript("OnClick",function() BK_MoveBarUp(5) end)
	_G["BKOptionsBarDown5"]:SetScript("OnClick",function() BK_MoveBarDown(5) end)
	_G["BKOptionsBarUp6"]:SetScript("OnClick",function() BK_MoveBarUp(6) end)
	_G["BKOptionsBarDown6"]:SetScript("OnClick",function() BK_MoveBarDown(6) end)
	_G["BKOptionsBarUp7"]:SetScript("OnClick",function() BK_MoveBarUp(7) end)
	_G["BKOptionsBarDown7"]:SetScript("OnClick",function() BK_MoveBarDown(7) end)
	_G["BKOptionsBarUp8"]:SetScript("OnClick",function() BK_MoveBarUp(8) end)
	_G["BKOptionsBarDown8"]:SetScript("OnClick",function() BK_MoveBarDown(8) end)
	_G["BKOptionsBarUp9"]:SetScript("OnClick",function() BK_MoveBarUp(9) end)
	_G["BKOptionsBarDown9"]:SetScript("OnClick",function() BK_MoveBarDown(9) end)
	_G["BKOptionsBarUp10"]:SetScript("OnClick",function() BK_MoveBarUp(10) end)
	--_G["BKOptionsBarDown10"]:SetScript("OnClick",BK_MoveBarDown(1))	--can't go lower!
	BKOptionsBarDown10:Hide()
	_G["BKOptionsBarToggle1"]:SetScript("OnClick",function() BK_ToggleBar(1) end)
	_G["BKOptionsBarToggle2"]:SetScript("OnClick",function() BK_ToggleBar(2) end)
	_G["BKOptionsBarToggle3"]:SetScript("OnClick",function() BK_ToggleBar(3) end)
	_G["BKOptionsBarToggle4"]:SetScript("OnClick",function() BK_ToggleBar(4) end)
	_G["BKOptionsBarToggle5"]:SetScript("OnClick",function() BK_ToggleBar(5) end)
	_G["BKOptionsBarToggle6"]:SetScript("OnClick",function() BK_ToggleBar(6) end)
	_G["BKOptionsBarToggle7"]:SetScript("OnClick",function() BK_ToggleBar(7) end)
	_G["BKOptionsBarToggle8"]:SetScript("OnClick",function() BK_ToggleBar(8) end)
	_G["BKOptionsBarToggle9"]:SetScript("OnClick",function() BK_ToggleBar(9) end)
	_G["BKOptionsBarToggle10"]:SetScript("OnClick",function() BK_ToggleBar(10) end)
	_G["BKOptionsBarColor1"]:SetScript("OnClick",function() BKColoredSpell=barOrder["BKBar1"]; BK_PickColor(BKSettings["barcolor"][barOrder["BKBar1"]])  end)
end

BKtwopointfour = "BADKITTY 2.0.4.\
\
Static bar order (pre-Cata functionality) is back!\
Check it in Bar Options.\
\
-Anatinus"

BKtwopointtwo = "BADKITTY 2.0.2. Stuff's gettin' added!\
\
Since the last update, I've put back in:\
-Predator's Swiftness Awareness\
-Ravage/Stampede Awareness\
-Warning layout and order adjustment\
-Bar height adjustment\
-Option to turn off bars scaling based on spell\
-Option to hide bars out of combat\
-Bar font size adjustment\
-Bars have an optional background haze\
\
\
BadKitty is still missing:\
-Shred/Rip Glyph\
-Bar locking (like the old BadKitty)\
-Color adjustments for everything\
-Bear form\
-Faerie Fire stacking (maybe)\
\
Updates are still rolling.  Thanks for being patient.\
\
-Anatinus"

BKtwopointone = "BADKITTY 2.0.1.  Like BadKitty 2.0.0, there's still a lot missing,\
but not everything!\
\
The following things work:\
Warnings and Bars for Mangle/Trauma/Hemo, Savage Roar, Rake,\
Rip, Berserk, Tiger's Fury, Faerie Fire, OOC.\
-Situationally-changing bar order\
-Frame movement\
-Warning size and text adjustment\
-Bar width adjustment\
-Bar hiding\
-The bars have names, now\
\
\
Stuff that still doesn't work includes:\
-Shred/Rip Glyph\
-Ravage/Stampede awareness\
-Warning layout\
-Bar Locking (like the old BadKitty)\
-Bear functionality\
-Color adjustments (for everything)\
-Any other option I didn't mention\
\
Updates are still rolling.  Keep checking.\
\
-Anatinus"

BKtwopointzero = "This is a super mega alpha version of BadKitty 2.  It's missing a lot, \
but everything presently implemented should work.\
\
This includes:\
-Full warning and bar tracking of Mangle/Trauma/Hemorrhage,\
Savage Roar, Berserk, Tiger's Fury, Faerie Fire, Rake, Rip,\
and Omen of Clarity.\
-Situationally-changing bar order\
-Frame movement\
\
The following things DON'T work yet:\
-Changing the order of Warnings\
-Ravage and Stampede\
-The Shred Glyph\
-Warning layout\
-Warning and Bar size\
-Bar locking (like the old BadKitty)\
-Font size and color adjustment for every frame\
-Bar color adjustment\
-Bear functionality\
-All other options I haven't mentioned\
\
I'll be working on getting everything back in over the \
next few weeks.  I really appreciate the positive feedback\
I've been receiving, and apologize for making you wait.\
\
--Anatinus\
\
PS: Oh, and as always, if you have a comment or suggestion,\
send it my way ;)"

